/*
** Der umstlpbare Wrfel nach Paul Schatz
** (C) 1999,2004 Franz Zahaurek <http://www.fzk.at>
**
** Dieses Programm samt Dokumentation ist Freie Software und kann beliebig
** verwendet werden, soferne der obige Copyright-Vermerk nicht entfernt
** wird.
*/
/* $id$ */

#ifndef OS_WIN32
  #include <config.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifndef OS_WIN32
#include <sys/time.h>
#include <unistd.h>
#endif
#include <sys/types.h>
#include <math.h>
#define DEFINECONSTANTS

#define CHECKOGLERR
#include "wuerfel.h"

int main(int argc, char **argv) {

    wIdent ();
    // wUsage ();

    glutInit (&argc, argv);

    wSetOptionDefaults ();

    wGetOptions (argc, argv);

    wBerechnewg();

    if (options.print) {
        fprintf (stderr, "Datenfiles wurden erstellet, sie enthalten %d Positionen des Wrfelgrtels\n",
                anzelt);
    }
    else {
        wControl ();
	fprintf (stderr, "Weiter mit einem Tastendruck\n");
	getchar ();
	fprintf (stderr, "Folgende Optionen sind eingestellt:\n");
	wDisplayOptions ();
	fprintf (stderr, "Weiter mit einem Tastendruck\n");
	getchar ();

        owgp = wg;
        wZeichnewg();
    }

    wFreewg();

    return 0;
}

void
wIdent (void) {
#ifdef OS_WIN32
    fprintf (stderr, "Der umstlpbare Wrfel nach Paul Schatz, Version: 3.5.8\n");
#else
    fprintf (stderr, "Der umstlpbare Wrfel nach Paul Schatz, Version: %s\n", VERSION);
#endif
    fprintf (stderr, "(C) 2004 Franz Zahaurek <http://www.fzk.at>\n");
}

void
wUsage (void) {
    fprintf (stderr, "\n");
    fprintf (stderr, "Optionen: -a     Achsen darstellen (Default=nein)\n");
    fprintf (stderr, "          -b     Berhrungslinie Wrfelgrtel/Zeitform ausgeben (nein)\n");
    fprintf (stderr, "          -c #   Achsentarnsformation vor Darstellung\n");
    fprintf (stderr, "                     0...keine\n");
    fprintf (stderr, "                     1...Winkel w um y-Achse = Kuboid\n");
    fprintf (stderr, "                     2...erst Winkel w/y, dann w2/x = Oloid\n");
    fprintf (stderr, "          -d #   Delta Winkelschrittweite (Default=6)\n");
    fprintf (stderr, "          -e     Endpunkte der Erzeugenden von Oloid/Kuboid (ja)\n");
    fprintf (stderr, "          -f     Koordinaten der Punkte ausgeben, dann exit\n");
    fprintf (stderr, "          -g     Gittermodell darstellen (nein)\n");
    fprintf (stderr, "          -h     Hilfetext ausgeben\n");
    fprintf (stderr, "          -i     Info zeigen (nein)\n");
    fprintf (stderr, "          -k     Kuboid darstellen (nein)\n");
    fprintf (stderr, "          -l     Labels darstellen (nein)\n");
    fprintf (stderr, "          -m #   Animationsmodus = Position des Betrachters, so dass ... (Default=1)\n");
    fprintf (stderr, "                     1...Hauptdiagonale fixiert ist\n");
    fprintf (stderr, "                     2...Scharnierkante fixiert ist\n");
    fprintf (stderr, "                     3...Element fixiert ist\n");
    fprintf (stderr, "          -o     Oloid darstellen (nein)\n");
    fprintf (stderr, "          -p     Perspektive- oder Parallelprojektion (parallel)\n");
    fprintf (stderr, "          -P #   bei dieser Positionsnummer starten und halten \n");
    fprintf (stderr, "          -r     Erzeugende Linien von Oloid/Kuboid (ja)\n");
    fprintf (stderr, "          -s #   Breite des Fensters in Pixeln (%d)\n",  FENSTER);
    fprintf (stderr, "          -t     Wrfelgrtel schwebt (nein)\n");
    fprintf (stderr, "          -v     Virtuelle Ecken darstellen (nein)\n");
    fprintf (stderr, "          -w     Wrfelgrtel darstellen (ja)\n");
}

void
wControl (void) {
    fprintf (stderr, "\n");
    fprintf (stderr, "Steuerung mit Hot-Keys:\n\n");
    fprintf (stderr, "  a            Toggle: Achsen zeigen/verbergen\n");
    fprintf (stderr, "  b            Toggle: Berhrungslinie ein/aus\n");
    fprintf (stderr, "  c            Achsentransformation: keine/Kuboid/Oloid\n");
    fprintf (stderr, "  e            Toggle: Endpunkte der Erzeugenden von Oloid/Kuboid ein/aus\n");
    fprintf (stderr, "  g            Toggle: Gitter-/Flchendarstellung\n");
    fprintf (stderr, "  i            Toggle: Info ein/aus\n");
    fprintf (stderr, "  k            Toggle: Kuboid ein/aus\n");
    fprintf (stderr, "  l            Toggle: Labels ein/aus\n");
    fprintf (stderr, "  o            Toggle: Oloid ein/aus\n");
    fprintf (stderr, "  p            Toggle: Projektion perspektivisch/parallel\n");
    fprintf (stderr, "  r            Toggle: Erzeugende von Oloid/Kuboid ein/aus\n");
    fprintf (stderr, "  s            Toggle: start/stopp\n");
    fprintf (stderr, "  t            Toggle: Schweben ein/aus\n");
    fprintf (stderr, "  v            Toggle: Virtuelle Ecken zeigen/verbergen\n");
    fprintf (stderr, "  w            Toggle: Wrfelgrtel ein/aus\n");
    fprintf (stderr, "  x/y/z        Drehung um +1 um die x/y/z-Achse\n");
    fprintf (stderr, "  X/Y/Z        Drehung um -1 um die x/y/z-Achse\n");
    fprintf (stderr, "  -/+          schneller/langsamer drehen\n");
    fprintf (stderr, "  ./,          Nchste/vorherige Position\n");
    fprintf (stderr, "  1/2/3        Animationsmodus: Diagonale/Scharnier/Element fxiert\n");
    fprintf (stderr, "  <HOME>       Drehung um x/y/z-Achse auf 0 stellen\n");
    fprintf (stderr, "  Pfeiltasten  Verschieben in x/y Richtung\n");
    fprintf (stderr, "  <PAGE_UP>,<PAGE_DOWN>  Verschieben in z Richtung\n");
    fprintf (stderr, "  <ESC>,q      Quit\n\n");
    fprintf (stderr, "\n");
    fprintf (stderr, "Steuerung mit der Maus:\n\n");
    fprintf (stderr, "  Rechte_Maustaste        Kontextmenue\n\n");
}

#ifdef OS_WIN32
void
wWarten (int sec) {
	return;
}


#else
void
wWarten (int sec){
    fd_set rfds;
    struct timeval tv;

    /* Watch stdin (fd 0) to see when it has input. */
    FD_ZERO(&rfds);
    FD_SET(0, &rfds);

    /* Wait up to sec seconds. */
    tv.tv_sec = sec;
    tv.tv_usec = 0;

    select(1, &rfds, NULL, NULL, &tv);
}
#endif

#ifdef OS_WIN32
/*
** Der Algorithmus zur Abarbeitung von Optionen entstammt dem Buch:
** A.T.Schreiner: System-Programmierung in UNIX, Teil 1: Werkzeuge
** Seite 136 ff
** Verlag: B.G. Teubner Stuttgart 1984
**
** Anmerkung: Man beachte die Konstruktionen: **++argv und *++*argv
*/
#define LOW  'a'
#define HIGH 'z'
#define VAL(x) vals[(x) - LOW]
static int vals[HIGH - LOW + 1];
#define XLOW  'A'
#define XHIGH 'Z'
#define XVAL(x) xvals[(x) - XLOW]
static int xvals[XHIGH - XLOW + 1];
void
wGetOptions (int argc, char **argv) {

    while (--argc) {
	char i;

	if (**++argv == '-') {

	    switch (i = *++*argv) {
	    case 0:
		/* alleinstehendes Minus wird ebergangen */
		fprintf (stderr, "einsames Minus wird berlesen\n");
		continue ;
	    case 'c':
	    case 'd':
	    case 'm':
	    case 'P':
	    case 's':
		if (*++*argv) {
		    if (i=='P') {
		   	XVAL (i) = atoi (*argv);
		    }	
		    else {
			VAL (i) = atoi (*argv);
/* 		    	fprintf (stderr, "Wert %c = %d\n", i, VAL(i)); */
		    }
		}
		else if (-- argc) {
		    if (i=='P') {
		    	XVAL (i) = atoi (*++argv);
		    }
		    else {
			VAL (i) = atoi (*++argv);
/* 		        fprintf (stderr, "Wert %c = %d\n", i, VAL(i)); */
		    }
		}
		else {
		    /* Wert zur Option fehlt */
		    fprintf (stderr, "Wert zur Option %c fehlt\n", i);
		    exit (1);
		    break;
		}
		switch (i) {
		case 'c':
		    options.axistrans = VAL(i);
		    if (options.axistrans < 0 || options.axistrans > 2) {
		        options.axistrans = 0;
		    }
		    break;
		case 'd':
		    options.dw = TOBWINKEL((double) VAL (i));
		    break;
		case 'm':
		    options.mode = VAL (i);
		    if (options.mode < 1 || options.mode > 3) {
			options.mode = 1;
		    }
		    break;
		case 'P':
		    options.position = XVAL (i);
		    break;
		case 's':
		    options.seite = VAL (i);
		    break;
		}
		continue;

	    case 'a':
		options.ach = TRUE;
		continue;

	    case 'b':
		options.touchline = TRUE;
		continue;

	    case 'e':
		options.endpunkte = FALSE;
		continue;

	    case 'f':
		options.print = TRUE;
		continue;

	    case 'g':
		options.lines = TRUE;
		polygonMode = GL_LINE;
		continue;

	    case 'h':
		wUsage ();
		wDisplayOptions ();
		exit (1);

	    case 'i':
		options.info = TRUE;
		continue;

	    case 'k':
        	if (! options.oloid) {
		  options.kuboid = TRUE;
		  options.axistrans = 1;
		}
		else {
		  fprintf (stderr, "Option -k ignoriert, da Oloid gewhlt ist\n");
		}
		continue;

	    case 'o':
        	if (! options.kuboid) {
		  options.oloid = TRUE;
		  options.axistrans = 2;
		}
		else {
		  fprintf (stderr, "Option -o ignoriert, da Kuboid gewhlt ist\n");
		}
		continue;

	    case 'p':
		options.perspektive = TRUE;
		continue;

	    case 'r':
		options.erzeugende = FALSE;
		continue;

	    case 't':
		options.tork = TRUE;
		continue;

	    case 'l':
		options.labels = TRUE;
		continue;

	    case 'v':
		options.virtuell = TRUE;
		continue;

	    case 'w':
		options.wuerfel = FALSE;
		continue;

	    default:
		/* Unbekannte Option */
		fprintf (stderr, "A Option %c\n", i);
		exit (1);
		continue;
	    }
	    break;
	}
        else {
		fprintf (stderr, "Unbekanntes Argument %s\n", *argv);
		exit (1);
	}
    }
}
#else
/*
** Unter LINUX besser getopt() verwenden
*/

void
wGetOptions (int argc, char **argv) {
    int c;
    extern int optind;

    optind = 1;
    while (TRUE) {
        extern int opterr, optopt;
        opterr = 0;

        c = getopt (argc, argv, "abc:d:efghiklm:opP:rs:tvw");
/*      fprintf (stderr, "getopt: c=%d, opterr=%d, optopt=%c, optarg=%s\n", */
/*               c, opterr, optopt, optarg); */
        if ( c == -1) {
            break;
        }

        switch (c) {
        case -1:
            break;

        case 'a':
            options.ach = TRUE;
            break;

        case 'b':
            options.touchline = TRUE;
            break;

        case 'c':
            options.axistrans = atoi (optarg);
	    if (options.axistrans < 0 || options.axistrans > 2) {
		options.axistrans = 0;
	    }
            break;

        case 'd':
            options.dw = TOBWINKEL((double)atoi (optarg));
            break;

        case 'e':
            options.endpunkte = FALSE;
            break;

        case 'f':
            options.print = TRUE;
            break;

        case 'g':
            options.lines = TRUE;
	    polygonMode = GL_LINE;
            break;

        case 'h':
            wUsage ();
	    fprintf (stderr, "Folgede Werte sind eingestellt:\n");
	    wDisplayOptions ();
            exit (1);

	case 'i':
	    options.info = TRUE;
	    break;

	case 'k':
            if (! options.oloid) {
	      options.kuboid = TRUE;
	      options.axistrans = 1;
	    }
	    else {
	      fprintf (stderr, "Option -k ignoriert, da Oloid gewhlt ist\n");
	    }
	    break;

        case 'm':
            options.mode = atoi (optarg);
	    if (options.mode < 1 || options.mode > 3) {
		options.mode = 1;
	    }
            break;

	case 'o':
	    if (! options.kuboid) {
	      options.oloid = TRUE;
	      options.axistrans = 2;
	    }
	    else {
	      fprintf (stderr, "Option -o ignoriert, da Kuboid gewhlt ist\n");
	    }
	    break;

        case 'P':
            options.position = atoi (optarg);
            break;

        case 'p':
            options.perspektive = TRUE;
            break;

        case 'r':
            options.erzeugende = FALSE;
            break;

        case 's':
            options.seite = atoi (optarg);
            break;

        case 't':
            options.tork = TRUE;
            break;

        case 'v':
            options.virtuell = TRUE;
            break;

        case 'w':
	    options.wuerfel = FALSE;
            break;

        case 'l':
            options.labels = TRUE;
            break;

        default:
            fprintf (stderr, "\n");
            fprintf (stderr, "Falsche Option oder fehlerhaftes Optionsargument: <%c>\n", optopt);
            /* wUsage (); */
            exit (1);
        }
    }
}
#endif

void
wSetOptionDefaults (void) {
    options.dw = 2. * M_PI / 60.;  /* Default-Schrittweite 360/60=6 im Bogenmass */

    options.seite = FENSTER;
    options.print = FALSE;
    options.virtuell = FALSE;
    options.ach = FALSE;

    options.lines = FALSE;
    polygonMode = GL_FILL;

    options.mode = 1;
    options.info = FALSE;
    options.tork = FALSE;
    options.perspektive = FALSE;
    options.labels = FALSE;
    options.kuboid = FALSE;
    options.oloid = FALSE;
    options.wuerfel = TRUE;
    options.touchline = FALSE;
    options.position = -1;
    options.erzeugende = TRUE;
    options.endpunkte = TRUE;
    options.axistrans = 0;
}

void
wDisplayOptions (void) {
    fprintf (stderr, "\n");
    fprintf (stderr, "Aktuelle Optionen und mit welcher Taste man sie ndern kann:\n");
    fprintf (stderr, "\n");
    fprintf (stderr, "Achsen          =%-4.4s -> a\n", options.ach?"ja":"nein");
    fprintf (stderr, "Achsentransform =%4d -> c\n", options.axistrans);
    fprintf (stderr, "Berhrungslinie =%-4.4s -> b\n", options.touchline?"ja":"nein");
    fprintf (stderr, "Endpunkte       =%-4.4s -> e\n", options.endpunkte?"ja":"nein");
    fprintf (stderr, "Erzeugende      =%-4.4s -> r\n", options.erzeugende?"ja":"nein");
    fprintf (stderr, "Kuboid          =%-4.4s -> k\n", options.kuboid?"ja":"nein");
    fprintf (stderr, "Labels          =%-4.4s -> l\n", options.labels?"ja":"nein");
    fprintf (stderr, "Oloid           =%-4.4s -> o\n", options.oloid?"ja":"nein");
    fprintf (stderr, "Wrfel          =%-4.4s -> w\n", options.wuerfel?"ja":"nein");
    fprintf (stderr, "info            =%-4.4s -> i\n", options.info?"ja":"nein");
    fprintf (stderr, "Gitter/Flchen  =%-4.4s -> g\n", options.lines?"ja":"nein");
    fprintf (stderr, "mode            =%4d -> 1/2/3\n", options.mode);
    fprintf (stderr, "perspektivisch  =%-4.4s -> p\n", options.perspektive?"ja":"nein");
    fprintf (stderr, "schweben/torkeln=%-4.4s -> t\n", options.tork?"ja":"nein");
    fprintf (stderr, "virtuell        =%-4.4s -> v\n", options.virtuell?"ja":"nein");
    fprintf (stderr, "Position        =%4d Startoption -P #\n", options.position);
    fprintf (stderr, "Delta Winkel    =%f Startoption -d #\n", options.dw);
    fprintf (stderr, "print           =%-4.4s Startoption -f\n", options.print?"ja":"nein");
    fprintf (stderr, "seite           =%4d Startoption -s #\n", options.seite);
}

void
wFreewg (void) {
    WG *wgp;

    wgp = wg;
    while (wgp) {
        WG *t;

        t = wgp;
        wgp = wgp->nextwgp;
        free (t);
    }
}
