/*
** Der umstlpbare Wrfel nach Paul Schatz
** (C) 1999,2004 Franz Zahaurek <http://www.fzk.at>
**
** Dieses Programm samt Dokumentation ist Freie Software und kann beliebig
** verwendet werden, soferne der obige Copyright-Vermerk nicht entfernt
** wird.
*/
#ifndef OS_WIN32
#include <config.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <GL/glut.h>
#include <GL/gl.h>

#define CHECKOGLERR
#include "wuerfel.h"

void
wKey (unsigned char key, int x, int y) {

/*   static int gkf = 0; */
/*   fprintf (stderr, "glutKeyboardFunc %d\n", ++gkf); */

    switch (key) {
    case 27: /* ESC */
    case 'q':
	exit (1);
    case '1':
    case '2':
    case '3':
/*     case '4': */
	wSubMenuModus ((int)(key - '0'));
        break;
    case '.':
	wNextPos ();
	break;
    case ',':
	wPrevPos ();
	break;
    case 'a':
	wToggleAxis ();
	break;
    case 'b':
	wToggleTouchline ();
	break;
    case 'c':
	wAdvanceAxisTransform ();
	break;
    case 'e':
	wToggleEndpunkte ();
	break;
    case 'g':
	wToggleGitterFlaechen ();
	break;
    case 'i':
        wToggleInfo ();
	break;
    case 'k':
        wToggleKuboid ();
	break;
    case 'l':
        wToggleLabels ();
	break;
    case 'o':
        wToggleOloid ();
	break;
    case 'p':
	wTogglePerspektive ();
	break;
    case 'r':
	wToggleErzeugende ();
	break;
    case 's':
	halt = !halt;
	break;
    case 't':
	wToggleTorkeln ();
	break;
    case 'v':
	wToggleVirtuell ();
	break;
    case 'w':
        wToggleWuerfelguertel ();
	break;
    case 'x':
	rotx += 1.;
	break;
    case 'y':
	roty += 1.;
	break;
    case 'z':
	rotz += 1.;
	break;
    case 'X':
	rotx -= 1.;
	break;
    case 'Y':
	roty -= 1.;
	break;
    case 'Z':
	rotz -= 1.;
	break;
    case '+':
	wSubMenuSpeed (1);
	break;
    case '-':
	wSubMenuSpeed (2);
	break;
    default:
	return;
    }
    wDisplayOptions ();
    wPostRedisplay ();
}

void
wSpecialKey (int key, int x, int y) {

/*   static int gsf = 0; */
/*   fprintf (stderr, "glutSpecialFunc %d\n", ++gsf); */

    switch (key) {
    case GLUT_KEY_UP:
	trany += 0.1;
	break;
    case GLUT_KEY_DOWN:
	trany -= 0.1;
	break;
    case GLUT_KEY_LEFT:
	tranx -= 0.1;
	break;
    case GLUT_KEY_RIGHT:
	tranx += 0.1;
	break;
    case GLUT_KEY_PAGE_UP:
	tranz += 0.1;
	break;
    case GLUT_KEY_PAGE_DOWN:
	tranz -= 0.1;
	break;
    case GLUT_KEY_HOME:
	rotx = roty = rotz = tranx = trany = tranz = 0.;
	drotx = droty = drotz = dtranx = dtrany = dtranz = 0.;
	options.axistrans = 0;
	wCreateDisplayLists ();
	break;
    default:
	return;
    }
    wPostRedisplay ();
}

void
wCreateMenus (void) {
    /* Modus-Submenue */
    menIdMainSubModus = glutCreateMenu (wSubMenuModus);
    glutAddMenuEntry ("<1> Hauptdiagonale fixiert", 1);
    glutAddMenuEntry ("<2> Scharnierkante fixiert", 2);
    glutAddMenuEntry ("<3> Element fixiert", 3);
/*     glutAddMenuEntry ("<4> Zentriert", 4); */

    /* Achsen-Transformations-Submenue */
/*     menIdMainSubAxis = glutCreateMenu (wSubMenuAxis); */
/*     glutAddMenuEntry ("<c> keine Achsentransformation", 1); */
/*     glutAddMenuEntry ("<c> Achsentransf. y", 2); */
/*     glutAddMenuEntry ("<c> Achsentransf. y+x", 3); */

    /* Geschwindigkeit-Submenue */
    menIdMainSubSpeed = glutCreateMenu (wSubMenuSpeed);
    glutAddMenuEntry ("<+> Schneller", 1);
    glutAddMenuEntry ("<-> Langsamer", 2);

    /* Create main menu for main window */
    menIdMain = glutCreateMenu (wMainMenu);
    if (options.tork) {
        glutAddMenuEntry ("<t> Schweben aus", 1);
    }
    else {
        glutAddMenuEntry ("<t> Schweben ein", 1);
    }
    if (options.virtuell) {
        glutAddMenuEntry ("<v> Virtuelle Ecken aus", 2);
    }
    else {
        glutAddMenuEntry ("<v> Virtuelle Ecken ein", 2);
    }
    if (options.ach) {
        glutAddMenuEntry ("<a> Achsen aus", 3);
    }
    else {
        glutAddMenuEntry ("<a> Achsen ein", 3);
    }
    if (options.perspektive) {
        glutAddMenuEntry ("<p> Projektion parallel", 4);
    }
    else {
        glutAddMenuEntry ("<p> Projektion perspektivisch", 4);
    }
    if (options.lines) {
        glutAddMenuEntry ("<g> Flchen", 5);
    }
    else {
        glutAddMenuEntry ("<g> Gitter", 5);
    }
    if (options.labels) {
        glutAddMenuEntry ("<l> Labels aus", 6);
    }
    else {
        glutAddMenuEntry ("<l> Labels ein", 6);
    }
    if (options.kuboid) {
        glutAddMenuEntry ("<k> Kuboid aus", 7);
    }
    else {
        glutAddMenuEntry ("<k> Kuboid ein", 7);
    }
    if (options.oloid) {
        glutAddMenuEntry ("<o> Oloid aus", 8);
    }
    else {
        glutAddMenuEntry ("<o> Oloid ein", 8);
    }
    if (options.wuerfel) {
        glutAddMenuEntry ("<w> Wrfelgrtel aus", 9);
    }
    else {
        glutAddMenuEntry ("<w> Wrfelgrtel ein", 9);
    }
    if (options.touchline) {
        glutAddMenuEntry ("<b> Berhrungslinie aus", 10);
    }
    else {
        glutAddMenuEntry ("<b> Berhrungslinie ein", 10);
    }
    if (options.erzeugende) {
        glutAddMenuEntry ("<r> Erzeugende aus", 11);
    }
    else {
        glutAddMenuEntry ("<r> Erzeugende ein", 11);
    }
    if (options.endpunkte) {
        glutAddMenuEntry ("<e> Endpunkte aus", 12);
    }
    else {
        glutAddMenuEntry ("<e> Endpunkte ein", 12);
    }
    if (options.info) {
        glutAddMenuEntry ("<i> Info aus", 13);
    }
    else {
        glutAddMenuEntry ("<i> Info ein", 13);
    }
    glutAddMenuEntry ("<c> nchste Achsentransf.", 14);

    glutAddSubMenu ("Geschwindigkeit", menIdMainSubSpeed);
    glutAddSubMenu ("Modus", menIdMainSubModus);
/*     glutAddSubMenu ("Achsentransf.", menIdMainSubAxis); */

    glutAddMenuEntry ("<q> Ende", 15);

    glutAttachMenu (GLUT_RIGHT_BUTTON);
}

void
wSubMenuModus (int value) {
    switch (value) {
    case 1:
    case 2:
    case 3:
	options.mode = value;
	break;
    }
}

void
wSubMenuAxis (int value) {
    wAdvanceAxisTransform ();
}

void
wSubMenuSpeed (int value) {
    switch (value) {
    case 1:
	waittime.tv_usec /= 2;
	break;
    case 2:
	if (waittime.tv_usec > 1000000) {
	    fprintf (stderr, "Zeitintervall bereits > 1 sek, Eingabe ignoriert\n");
	    return;
	}
        waittime.tv_usec *= 2;
	if (waittime.tv_usec == 0) {waittime.tv_usec = 1;}
	break;
    }
fprintf (stderr, "Aktuelles Zeitintervall = %ld\n", waittime.tv_usec);
}

void
wMainMenu(int value){

    switch(value){

    case 1:
	wToggleTorkeln ();
	break;

    case 2:
	wToggleVirtuell ();
	break;

    case 3:
	wToggleAxis ();
	break;

    case 4:
	wTogglePerspektive ();
	break;

    case 5:
	wToggleGitterFlaechen ();
	break;

    case 6:
	wToggleLabels ();
	break;

    case 7:
	wToggleKuboid ();
	break;

    case 8:
	wToggleOloid ();
	break;

    case 9:
	wToggleWuerfelguertel ();
	break;

    case 10:
	wToggleTouchline ();
	break;

    case 11:
	wToggleErzeugende ();
	break;

    case 12:
	wToggleEndpunkte ();
	break;

    case 13:
	wToggleInfo ();
	break;

    case 14:
	wAdvanceAxisTransform ();
	break;

    case 15:
	wExit ();
	break;
    }
}

void
wToggleTorkeln (void) {
      if(options.tork) {
	  glutChangeToMenuEntry(1, "<t> Schweben ein", 1);
      }
      else {
	  glutChangeToMenuEntry(1, "<t> Schweben aus", 1);
      }
      options.tork = ! options.tork;
}

void
wToggleVirtuell (void) {
      if(options.virtuell) {
	  glutChangeToMenuEntry(2, "<e> Virtuelle Ecken ein", 2);
      }
      else {
	  glutChangeToMenuEntry(2, "<e> Virtuelle Ecken aus", 2);
      }
      options.virtuell = ! options.virtuell;
}

void
wToggleAxis (void) {
      if(options.ach) {
	  glutChangeToMenuEntry(3, "<a> Achsen ein", 3);
      }
      else {
	  glutChangeToMenuEntry(3, "<a> Achsen aus", 3);
      }
      options.ach = ! options.ach;
}

void
wTogglePerspektive (void) {
      if(options.perspektive) {
	  glutChangeToMenuEntry(4, "<p> Projektion perspektivisch", 4);
      }
      else {
	  glutChangeToMenuEntry(4, "<p> Projektion parallel", 4);
      }
      options.perspektive = ! options.perspektive;
      wReshape (options.seite, options.seite);
}

void
wToggleGitterFlaechen (void) {
      if(options.lines) {
	  glutChangeToMenuEntry(5, "<g> Gitter", 5);
      }
      else {
	  glutChangeToMenuEntry(5, "<g> Flchen", 5);
      }
      options.lines = ! options.lines;
      if (polygonMode == GL_LINE) {
	  polygonMode = GL_FILL;
      }
      else {
	  polygonMode = GL_LINE;
      }
      wErr(glPolygonMode (GL_FRONT_AND_BACK, polygonMode));
}

void
wToggleLabels (void) {
      if(options.labels) {
	  glutChangeToMenuEntry(6, "<l> Labels ein", 6);
      }
      else {
	  glutChangeToMenuEntry(6, "<l> Labels aus", 6);
      }
      options.labels = ! options.labels;
      wCreateDisplayLists ();
}

void
wToggleKuboid (void) {
      if(options.kuboid) {
	  options.kuboid = FALSE;
	  glutChangeToMenuEntry(7, "<k> Kuboid ein", 7);
      }
      else {
          options.kuboid = TRUE;
/* 	  fprintf (stderr, "Tipps: c...Achsentransformation wechseln\n"); */
/* 	  fprintf (stderr, "       r...Toggle: Erzeugende des Kuboid darstellen\n"); */
/* 	  fprintf (stderr, "       e...Toggle: Endpunkte der Erzeugenden\n"); */
/* 	  fprintf (stderr, "       b...Toggle: Berhrungslinie Grtel/Oloid\n"); */
/* 	  fprintf (stderr, "       w...Toggle: Wrfelgrtel darstellen\n"); */
/* 	  fprintf (stderr, "       g...Toggle: Grtel flchig oder als Gitter\n"); */
	  glutChangeToMenuEntry(7, "<k> Kuboid aus", 7);
          options.oloid = FALSE;
	  glutChangeToMenuEntry(8, "<o> Oloid ein", 8);
	  options.axistrans = 1; /* Achsentransformation fuer Kuboid */
	  rotx = rotz = 0;
/* 	  roty = 90; */
      }
      wCreateDisplayLists ();
}

void
wToggleOloid (void) {
      if(options.oloid) {
	  options.oloid = FALSE;
	  glutChangeToMenuEntry(8, "<o> Oloid ein", 8);
      }
      else {
          options.oloid = TRUE;
/* 	  fprintf (stderr, "Tipps: c...Achsentransformation wechseln\n"); */
/* 	  fprintf (stderr, "       r...Toggle: Erzeugende des Oloid darstellen\n"); */
/* 	  fprintf (stderr, "       e...Toggle: Endpunkte der Erzeugenden\n"); */
/* 	  fprintf (stderr, "       b...Toggle: Berhrungslinie Grtel/Oloid\n"); */
/* 	  fprintf (stderr, "       w...Toggle: Wrfelgrtel darstellen\n"); */
/* 	  fprintf (stderr, "       g...Toggle: Grtel flchig oder als Gitter\n"); */
	  glutChangeToMenuEntry(8, "<o> Oloid aus", 8);
	  options.kuboid = FALSE;
	  glutChangeToMenuEntry(7, "<k> Kuboid ein", 7);
	  options.axistrans = 2; /* Achsentransformation fuer Oloid */
	  rotx = rotz = 0;
/* 	  roty = 90; */
	  if (! options.erzeugende) {
	      wToggleErzeugende();
	  }
	  if (! options.endpunkte) {
	      wToggleEndpunkte();
	  }
      }
      wCreateDisplayLists ();
}

void
wToggleWuerfelguertel (void) {
      if(options.wuerfel) {
	  glutChangeToMenuEntry(9, "<w> Wrfelguertel ein", 9);
      }
      else {
	  glutChangeToMenuEntry(9, "<w> Wrfelguertel aus", 9);
      }
      options.wuerfel = ! options.wuerfel;
}

void
wToggleTouchline (void) {
      if(options.touchline) {
	  glutChangeToMenuEntry(10, "<b> Berhrungslinie ein", 10);
      }
      else {
	  glutChangeToMenuEntry(10, "<b> Berhrungslinie aus", 10);
      }
      options.touchline = ! options.touchline;
      wCreateDisplayLists ();
}

void
wToggleErzeugende (void) {
      if(options.erzeugende) {
	  glutChangeToMenuEntry(11, "<r> Erzeugende ein", 11);
      }
      else {
	  glutChangeToMenuEntry(11, "<r> Erzeugende aus", 11);
      }
      options.erzeugende = ! options.erzeugende;
      wCreateDisplayLists ();
}

void
wToggleEndpunkte (void) {
      if(options.endpunkte) {
	  glutChangeToMenuEntry(12, "<e> Endpunkte ein", 12);
      }
      else {
	  glutChangeToMenuEntry(12, "<e> Endpunkte aus", 12);
      }
      options.endpunkte = ! options.endpunkte;
      wCreateDisplayLists ();
}

void
wAdvanceAxisTransform (void) {
      options.axistrans = (options.axistrans + 1) % 3;
      fprintf (stderr, "Achsentransformation steht auf %d\n", options.axistrans);
      wCreateDisplayLists ();
}

void
wToggleInfo (void) {
      if(options.info) {
	  glutChangeToMenuEntry(13, "<i> Info ein", 13);
      }
      else {
	  glutChangeToMenuEntry(13, "<i> Info aus", 13);
      }
      glutSetWindow (winIdSub);
      if (options.info) {
          glutHideWindow();
      }
      else {
          glutShowWindow();
      }
      options.info = ! options.info;
}

void
wExit (void) {
    exit (1);
}
